import 'package:blocstar/DataManagement/Mergeable.dart';
import 'package:flutter/material.dart';

import 'ActionState.dart';

abstract class BlocContextBase<TBlocContext>
    implements Mergeable<TBlocContext> {
  ActionState actionState;
  final Function(ActionState, TBlocContext updatedContext) onContextChanged;

  BlocContextBase(this.onContextChanged) {
    actionState = new ActionState(false, false, null, onContextChanged);
    onContextChanged(actionState, this as TBlocContext);
  }

  @protected
  BlocContextBase<TBlocContext> mergeAppState(
      BlocContextBase<TBlocContext> newModel) {
    newModel.actionState =
        new ActionState(false, false, null, actionState.onActionStateChanged);
    return newModel;
  }
}
